;;  -------------------------------------------------------------------
;;  NOM:        PATROEXE.ASM
;;  CREAT PER:  Coordinador EC I (2000/2001)
;;  DATA:       02/MAR/2001
;;  DESCRIPCIO: fitxer en "ASM" amb l'estructura bsica d'un programa
;;              per generar un executable de tipus "EXE" a partir d'un
;;              nic mdul de codi.
;;  -------------------------------------------------------------------

        ASSUME cs:Codi, ds:Dades, ss:Pila

Pila SEGMENT STACK 'stack'      ; Declaraci del Segment de pila
        DW 256 DUP (?)          ; (pot contenir fins a 256 words)
Pila ENDS



Dades SEGMENT           ; Declaraci del Segment de dades
        ; Lloc per posar la DEFINICIO DE LES VARIABLES:
        ;                   ##########################
	Matriu	DB	1,  2,  3,  4,  5,  6,  7,  8
		DB	2, 10, 11,  0,  1, 20,  4,  5
		DB	2, 10, 11,  0,  1, 20,  4,  5
		DB	1,  2,  3,  4,  5,  6,  7,  8
	
	Vector  DB	8,  7,  6,  5,  4,  3,  2,  1
	
        Result	DW 4 DUP (?)
        
Dades ENDS



Codi SEGMENT            ; Declaraci del Segment de codi
        ; Lloc per posar el CODI DE LES SUBRUTINES:
        ;                   ######################

DesplElemTau2D PROC
	push	dx
	push	ax
	push	cx
	sub	dh, dl
	mov	al, dh
	mul	bl		; Resultat 1 en AX
	
	sub	ch, cl
	mov	cl, 0
	xchg	ch, cl		; Resultat 2 en CX
	
	add	ax, cx
	mul	bh		; Resultat final a AX
	
	mov	di, ax
	pop	cx
	pop	ax
	pop	dx
	ret
DesplElemTau2D ENDP



Principal PROC          ; Programa principal: s el que s'executar
        mov     ax, Dades       ; Inicialitzar DS per poder accedir a
        mov     ds, ax          ;       les variables del segment Dades
    
        ; Lloc per posar el CODI DEL PROGRAMA PRINCIPAL:
        ;                   ###########################

	mov	cl, 2
per1:	cmp	cl, 5
	ja	fper1
	mov	dx, 0
	mov	ch, 1
per2:	cmp	ch, 8
	ja	fper2
	push	dx
	push	cx
	
	; Posicio de la matriu
	mov	dh, cl		;Fila
	mov	ch, ch		;Ja esta, aixo sobra
	mov	dl, 2		;Fila inicial
	mov	cl, 1		;Columna inicial
	mov	bl, 8		;Num de columnes
	mov	bh, TYPE Matriu	;Mida de l'element
	call	DesplElemTau2D	;Calculem posicio, que guardara a DI
	
	mov	al, Matriu[di]

	; Posicio del vector
	mov	dh, 1		;Fila
	mov	ch, ch		;Ja esta, aixo sobra
	mov	dl, 1		;Fila inicial
	mov	cl, 1		;Columna inicial
	mov	bl, 8		;Num de columnes
	mov	bh, TYPE Vector	;Mida de l'element
	call	DesplElemTau2D	;Calculem posicio, que guardara a DI

	mul	Vector[di]
	
	pop	cx
	pop	dx
	
	add	dx, ax
	
	inc	ch
	jmp	per2
fper2:
	mov	bl, cl
	xor	bh, bh
	shl	bx, 1			; Multipliquem per 2 pq es un Word
	mov	Result[bx-4], dx	; Restem 4 per ser un Word
	
	inc	cl
	jmp	per1
fper1:	
	
	

        mov     ah, 4Ch         ; Indicar al SO que s'ha acabat el programa
        mov     al, 0           ;       Codi de sortida (Exit code)
        int     21h
Principal ENDP


Codi ENDS


        END     Principal

