;;  -------------------------------------------------------------------
;;  NOM:        PATROEXE.ASM
;;  CREAT PER:  Coordinador EC I (2000/2001)
;;  DATA:       02/MAR/2001
;;  DESCRIPCIO: fitxer en "ASM" amb l'estructura bsica d'un programa
;;              per generar un executable de tipus "EXE" a partir d'un
;;              nic mdul de codi.
;;  -------------------------------------------------------------------

        ASSUME cs:Codi, ds:Dades, ss:Pila

Pila SEGMENT STACK 'stack'      ; Declaraci del Segment de pila
        DW 256 DUP (?)          ; (pot contenir fins a 256 words)
Pila ENDS



Dades SEGMENT           ; Declaraci del Segment de dades
        ; Lloc per posar la DEFINICIO DE LES VARIABLES:
        ;                   ##########################

        
Dades ENDS



Codi SEGMENT            ; Declaraci del Segment de codi
        ; Lloc per posar el CODI DE LES SUBRUTINES:
        ;                   ######################



Principal PROC          ; Programa principal: s el que s'executar
        mov     ax, Dades       ; Inicialitzar DS per poder accedir a
        mov     ds, ax          ;       les variables del segment Dades
    
        ; Lloc per posar el CODI DEL PROGRAMA PRINCIPAL:
        ;                   ###########################



        mov     ah, 4Ch         ; Indicar al SO que s'ha acabat el programa
        mov     al, 0           ;       Codi de sortida (Exit code)
        int     21h
Principal ENDP


Codi ENDS


        END     Principal

